package domain

import "strings"

type RedisKey string

const (
	OrderRedisKey RedisKey = "id"
	RememberME    RedisKey = "remember_me"
)

func (key RedisKey) ToString() string {
	return "order:" + string(key)
}

func (key RedisKey) With(s ...string) RedisKey {
	parts := append([]string{string(key)}, s...)

	return RedisKey(strings.Join(parts, ":"))
}

func GetOrderRedisKey(id string) string {
	return OrderRedisKey.With(id).ToString()
}

func GetRememberMeRedisKey(uid string) string {
	return RememberME.With(uid).ToString()
}
